ApplicationModel subclass: #FocusTest
	instanceVariableNames: 'inputField '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STBE-FocusTest'!
FocusTest comment:
'This class demonstrates a way to cancel out of a screen even though a field still fails the validation test. For this to work, you must have:
	1) Added an instance variable called controllerRequestingFocus to class KeyboardProcessor.
	2) Filed in keyproc.st from the sysadds directory.
	3) Filed in keyproc.st from the sysmods directory.
These three things ensure that the keyboard processor keeps track of the widget that is requesting the focus. Once we know which widget is requesting the focus, we can test to see if the user pressed the Cancel button.'!


!FocusTest methodsFor: 'validation'!

cancelPressed
	^self builder keyboardProcessor controllerRequestingFocus == 
		(self builder componentAt: #cancelAB) widget controller!

validate: aController 
	self cancelPressed ifTrue: [^true].
	^aController hasEditValue
		ifTrue: [true]
		ifFalse: 
			[Dialog warn: 'Please enter a valid date'.
			false]! !

!FocusTest methodsFor: 'aspects'!

inputField
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^inputField isNil
		ifTrue:
			[inputField := nil asValue]
		ifFalse:
			[inputField]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

FocusTest class
	instanceVariableNames: ''!


!FocusTest class methodsFor: 'opening'!

example
	"self example"

	self open! !

!FocusTest class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#Rectangle 507 401 707 547 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#InputFieldSpec 
					#layout: #(#Rectangle 71 28 166 58 ) 
					#name: #inputFieldIF 
					#model: #inputField 
					#callbacksSpec: 
					#(#UIEventCallbackSubSpec 
						#requestFocusOutSelector: 
						#validate: ) 
					#type: #date ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 13 84 76 115 ) 
					#name: #okAB 
					#model: #closeRequest 
					#label: 'OK' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 104 83 171 115 ) 
					#name: #cancelAB 
					#model: #closeRequest 
					#label: 'Cancel' 
					#defaultable: true ) 
				#(#LabelSpec 
					#layout: #(#Point 15 29 ) 
					#label: 'Date:' ) ) ) )! !

